all: cinc casm

# compiler
CC = cc

# debug uncomment the following line for debugging
# GDB = -g

cinc:		obj/cinc.o obj/cinc_cpu.o obj/cinc_init_hw.o obj/cpu_micro_code.o obj/setopts.o
	$(CC) $(GDB) -o bin/cinc obj/cinc.o obj/cinc_cpu.o obj/cinc_init_hw.o obj/cpu_micro_code.o obj/setopts.o

casm:	src/casm.tab.c src/casm.tab.h src/casmutls.c 
	$(CC) $(GDB) src/lex.yy.c src/casm.tab.c src/casmutls.c -o bin/casm -I src -I-

src/lex.yy.c:	src/casm.l
	./makelex

src/casm.tab.c:	src/lex.yy.c src/casm.y
	./makebison

obj/cinc.o:		src/cinc.c includes/cinc.h includes/config.h 
	$(CC) $(GDB) -o obj/cinc.o -c src/cinc.c -I includes -I-
obj/cinc_cpu.o:		src/cinc_cpu.c includes/config.h includes/cpu_micro_code.h
	$(CC) $(GDB) -o obj/cinc_cpu.o -c src/cinc_cpu.c -I includes -I-
obj/cinc_init_hw.o:		src/cinc_init_hw.c includes/config.h
	$(CC) $(GDB) -o obj/cinc_init_hw.o -c src/cinc_init_hw.c -I includes -I-
obj/cpu_micro_code.o:		src/cpu_micro_code.c includes/config.h
	$(CC) $(GDB) -o obj/cpu_micro_code.o -c src/cpu_micro_code.c -I includes -I-
obj/setopts.o:			src/setopts.c includes/config.h
	$(CC) $(GDB) -o obj/setopts.o -c src/setopts.c  -I includes -I-
install:
	cp ./bin/cinc /usr/local/bin/
	cp ./bin/casm /usr/local/bin/
uninstall:
	rm /usr/local/bin/cinc
	rm /usr/local/bin/casm
clean:
	rm -f obj/*.o
