
/*  A Bison parser, made from casm.y
    by GNU Bison version 1.28  */

#define YYBISON 1  /* Identify Bison output.  */

#define	NUMBER	257
#define	OPER	258
#define	INSTRUCTION	259
#define	LABEL	260
#define	LABTERM	261
#define	EOL	262
#define	GARBAGE	263

#line 32 "casm.y"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include "casm.data.h"
#include "casm.h"

#define EMPTY    0
#define SYMBOLIC 1
#define NUMERIC  2
#define VERSION "2.1.3"


  FILE * out;

  /* jrv2 */
  extern FILE * yyin;


  struct sym_table * sym_ptr;
  struct sym_table * search_ptr;
  
  struct sym_table * proc_sym_ptr;

  struct cardiac_code * start_ptr;
  struct cardiac_code * end_ptr;

  struct proc_stack * top_proc_stack;
  
  int line ;   /* Tracks input lines. Used to display error messages */
  int loc = 1; /* Tracks mempry locations during code generation */
  int value;       /* used in different contexts as a utility variable */
  int optype;      /* Operator type */
  int labeltype;   /* Label type */
  int casm_error = FALSE;  /* Error indicator */ 
  int rc;             /* return codes */
  char * temp_str;    /* a temporary string variable */

  void yyerror(const char *str)
    {
      fprintf(stderr,"casm:%s at line %d\n\n",str,line);
      casm_error = TRUE;
    }
  int yywrap()
    {
      return 1;
    }

  /* 
     These functions should probably go in casmutls.c. It was easier
     easier to debug with the code here, eventually I will move this
     code over.

     When these functions are move, they must be fully parametrize
     to avoid accessing external variables. 
   */
  
  /* Generate instructions JMP MAIN and HRS */
  int proc_main()
    { 
      int value;

      /* Unresolved JMP, to be resolved by MAIN: PROC */
      value=800; /* load return address */
      code_add(&start_ptr,&end_ptr,loc,value);
      proc_symbol(&sym_ptr,"MAIN",end_ptr);
      loc ++;
      /* HRS */
      value=900;
      code_add(&start_ptr,&end_ptr,loc,value);
      loc++;      
    }

  int proc_stack_push(struct proc_stack * * top, 
		      struct sym_table * sym_ptr)
    {
      struct proc_stack * temp;

      temp = malloc(sizeof( struct proc_stack ) );
      temp->sym_ptr = sym_ptr;
      temp->next = *top;
      *top = temp;
    }

  int proc_stack_pop(struct proc_stack * * top,
		     struct sym_table * * sym_ptr)
    {
      struct proc_stack * temp;
      struct proc_stack * t;
      struct sym_table * s_ptr;

      t = *top;
      if ( t != NULL ) {
	*sym_ptr = t->sym_ptr;
	temp = t;
	*top = t->next;
	free(temp);
      } else {
	*sym_ptr = NULL;
      }
    }

  int add_label(struct sym_table * *s,char * label,int value)
    {
      int rc = 0;
      /* add label to symbol table */
      search_ptr = *s;
      sym_table_search(&search_ptr,label);
      
      if (search_ptr != NULL) {
	if (search_ptr->backpatch_ptr != NULL) {
	  /* Symbol existed, but was unresolved, we now have resolution */
	  search_ptr->value=value;
	  bkpatch(search_ptr);
	  rc = 2;
	} else {
	  /* Duplicate symbol put error message */
	  fprintf(stderr,"Duplicate symbol \"%s\"\n",label);
	  yyerror("parser error");
	  rc = 1;
	}
      } else {
	/* New symbol must be added */
	sym_table_add(s,label,value);
      }
      return(rc);
    }
  
  int proc_symbol(struct sym_table **s,char * symbol,struct cardiac_code * code_ptr)
    {
      search_ptr = *s;
      sym_table_search(&search_ptr,symbol);	     
      if (search_ptr == NULL) {
	/* Symbol is undefined */
	sym_table_unresolved_new(s,symbol,code_ptr);
	end_ptr->unresolved_symbol_ptr = *s;
      } else {
	/* Symbol is defined */
	if (search_ptr->backpatch_ptr == NULL){
	  /* Bingo! The symbol is defined and has resolution */
	  code_ptr->cell = code_ptr->cell + search_ptr->value;
	} else {
	  /* The symbol is defined, but unresolved */
	  sym_table_unresolved_add(search_ptr,code_ptr);
	  code_ptr->unresolved_symbol_ptr = search_ptr;
	}
      }
    }
  
  
#line 184 "casm.y"
typedef union {
  char * sval;
  int    ival;
} YYSTYPE;
#ifndef YYDEBUG
#define YYDEBUG 1
#endif

#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		20
#define	YYFLAG		-32768
#define	YYNTBASE	10

#define YYTRANSLATE(x) ((unsigned)(x) <= 263 ? yytranslate[x] : 16)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     1,     4,     8,    10,    13,    16,    20,    24,    25,
    28,    29,    31
};

static const short yyrhs[] = {    -1,
    10,    11,     0,    10,     1,     8,     0,     8,     0,    12,
     8,     0,    13,     8,     0,    14,     5,    15,     0,    14,
     4,    15,     0,     0,     6,     7,     0,     0,     6,     0,
     3,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   200,   201,   202,   211,   212,   213,   228,   376,   409,   410,
   413,   419,   425
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","NUMBER",
"OPER","INSTRUCTION","LABEL","LABTERM","EOL","GARBAGE","input","lines","instruction",
"operation","label","operand", NULL
};
#endif

static const short yyr1[] = {     0,
    10,    10,    10,    11,    11,    11,    12,    13,    14,    14,
    15,    15,    15
};

static const short yyr2[] = {     0,
     0,     2,     3,     1,     2,     2,     3,     3,     0,     2,
     0,     1,     1
};

static const short yydefact[] = {     1,
     0,     0,     0,     4,     2,     0,     0,     0,     3,    10,
     5,     6,    11,    11,    13,    12,     8,     7,     0,     0
};

static const short yydefgoto[] = {     1,
     5,     6,     7,     8,    17
};

static const short yypact[] = {-32768,
     0,     1,     5,-32768,-32768,     3,     6,    -2,-32768,-32768,
-32768,-32768,     4,     4,-32768,-32768,-32768,-32768,    13,-32768
};

static const short yypgoto[] = {-32768,
-32768,-32768,-32768,-32768,     2
};


#define	YYLAST		16


static const short yytable[] = {    19,
     2,    13,    14,    -9,    -9,     3,    15,     4,     9,    16,
    11,    10,    20,    12,     0,    18
};

static const short yycheck[] = {     0,
     1,     4,     5,     4,     5,     6,     3,     8,     8,     6,
     8,     7,     0,     8,    -1,    14
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/lib/bison.simple"
/* This file comes from bison-1.28.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 217 "/usr/lib/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
int yyparse (void *);
#else
int yyparse (void);
#endif
#endif

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
  int yyfree_stacks = 0;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 1:
#line 200 "casm.y"
{ yyval.sval = ""  ; ;
    break;}
case 3:
#line 203 "casm.y"
{ 
	   line++;
	   fprintf(stderr,"Unrecognizible string. \n");
	   yyerror("parse error");
	   yyerrok;
	 ;
    break;}
case 4:
#line 211 "casm.y"
{yyval.sval = ""; line++;;
    break;}
case 5:
#line 212 "casm.y"
{line++;;
    break;}
case 6:
#line 213 "casm.y"
{line++;;
    break;}
case 7:
#line 229 "casm.y"
{
	   rc = 0;
	   if ( ! strcmp(yyvsp[-1].sval,"EQU") ) {
	     if ( optype != NUMERIC ) {
	       fprintf(stderr,"Numeric operand expected\n");
	       yyerror("parse error");
	       YYERROR;
	     } else {
	       /* jrv1 value should be between 1 and 99 */
	       if ( (yyvsp[0].ival < 0) || (yyvsp[0].ival > 99) ) {
		 fprintf(stderr,"Value out of bounds\n");
		 yyerror("parse error");
		 YYERROR;
	       } else { 
		 if ( labeltype == EMPTY ) {
		   fprintf(stderr,"Label expected\n");
		   yyerror("parse error");
		   YYERROR;
		 } else {
		   /* EQU instruction just creates a table entry */
		   rc = add_label(&sym_ptr,yyvsp[-2].sval,yyvsp[0].ival);
		   if (  rc == 1  ) {
		     /* 
			add_label calls yyerror however, the YYERROR 
			macro is called here since it cannot be outside
			the scope of the Bison grammer section.
		     */
		     YYERROR;
		   }
		 }
	       }
	     }
	   }
	 

	   if ( ! strcmp(yyvsp[-1].sval,"CEL") ) { 
	     /* Generate code for CEL */
	     
	     code_add(&start_ptr,&end_ptr,loc,yyvsp[0].ival);
	     
	     if ( labeltype == EMPTY || optype == EMPTY) {
	       fprintf(stderr,"Label and operand expected\n");
	       yyerror("parse error");
	       YYERROR;	       
	     } else {
	       rc = add_label(&sym_ptr,yyvsp[-2].sval,loc);
	       loc++;
	     }
	   }
		
	   if ( ! strcmp(yyvsp[-1].sval,"PROC") ) { 
	     /* 
		Generate the cardiac code for PROC and setup the 
		return stuff. 
	     */

	     /* 
		One PROC instruction actully generates code for two
		cardiac instructions. One to load the return instruction
		to the accumulator (199) and one to store the return
		instruction at a location to be determine by a matching
		ENDP instruction.

		This allows casm to generate code for procedures. It is
		one of the percs that the assembler offers over machine code
		programming.
	     */
	     value=199; /* load return address */
	     code_add(&start_ptr,&end_ptr,loc,value);
	     rc = add_label(&sym_ptr,yyvsp[-2].sval,loc);	 
	     
	     if ( rc != 1 ) {
	       loc ++;
	       
	       /* 
		  Find the entry for the label in the symbol table
		  and push this pointer into a stack so that it
		  can late be mateched to an ENDP instruction.
	       */
	       
	       search_ptr = sym_ptr;
	       sym_table_search(&search_ptr,yyvsp[-2].sval);
	       proc_stack_push(&top_proc_stack,search_ptr);
	       
	       /*
		 A STO operation is created to an unresolved symbol so that
		 when the symbol gets resolved, the generated code will be
		 6xx where xx is the return address for the symbol.
	       */
	       value=600; /* store to undefined symbol */ 
	       code_add(&start_ptr,&end_ptr,loc,value);
	       loc++;
	       
	       /* Create an unresolved symbol name the same as the label with
		  a # at the end. This unique symbol is for internal use only.
		  The purpose is to generate code that will allow us to return
		  to the calling procedure.
	       */
	       yyvsp[-2].sval = strcat(yyvsp[-2].sval,"#");	     
	       proc_symbol(&sym_ptr,yyvsp[-2].sval,end_ptr);
	     }
	   }
	   
	   if ( ! strcmp(yyvsp[-1].sval,"ENDP")) { 
	     /* Generate code for ENDP */
	     value = 800;
	     code_add(&start_ptr,&end_ptr,loc,800);

	     rc = 0;

	     if (labeltype != EMPTY) {
	       /* add label to symbol table */
	       rc = add_label(&sym_ptr,yyvsp[-2].sval,loc);
	     }

	   
	     
	     proc_sym_ptr = NULL;
	     proc_stack_pop(&top_proc_stack,&proc_sym_ptr);

	     if ( proc_sym_ptr == NULL ) {
	       /* Error unmatched ENDP */
	       fprintf(stderr,"Unmatched ENDP instruction\n");
	       yyerror("parse error");
	       YYERROR;
	     } else {
	       /* 
		  OK, now generate a resolution for the internal label
		  created by PROC (the one with the # at the end).  
	       */
	       temp_str = strdup(proc_sym_ptr->symbol);
	       temp_str = strcat(temp_str,"#");
	       rc = add_label(&sym_ptr,temp_str,loc);	       
	       free(temp_str);
	     }

	     if ( optype != EMPTY || rc == 1 ) {
	       yyerror("parse error");
	       YYERROR;	       
	     }

	     loc++;
	   }

	 ;
    break;}
case 8:
#line 377 "casm.y"
{
	     code_add(&start_ptr,&end_ptr,loc,yyvsp[-1].ival);
	     
	     if (labeltype != EMPTY) {
	       /* add label to symbol table */
	       rc = add_label(&sym_ptr,yyvsp[-2].sval,loc);
	     }
	     
	     if (optype == EMPTY) {
	       fprintf(stderr,"Operand expected\n");
	       yyerror("parse error");
	       YYERROR;
	     }
	     
	     if (optype == SYMBOLIC) {
	       proc_symbol(&sym_ptr,yyvsp[0].sval,end_ptr);
	     }
	     
	     if (optype == NUMERIC) {
	       if ( value < 0 || value > 99 ) {
		 fprintf(stderr,"Value out of bounds\n");
		 yyerror("parse error");
		 YYERROR;
	       } else {
		 end_ptr->cell=end_ptr->cell+value;
	       }
	     }
	     loc++;
	     
	   ;
    break;}
case 9:
#line 409 "casm.y"
{ yyval.sval = ""; labeltype=EMPTY;
    break;}
case 10:
#line 410 "casm.y"
{labeltype=SYMBOLIC;;
    break;}
case 11:
#line 414 "casm.y"
{ 
		yyval.sval=""; 
		optype=EMPTY; 
		value=0; 
	      ;
    break;}
case 12:
#line 420 "casm.y"
{ 
		yyval.sval = yyvsp[0].sval;
		optype = SYMBOLIC;
		value = 0;
	      ;
    break;}
case 13:
#line 426 "casm.y"
{ 
		yyval.ival = yyvsp[0].ival; 
		optype = NUMERIC; 
		value=yyvsp[0].ival;
	      ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 543 "/usr/lib/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 1;
}
#line 435 "casm.y"



main(int argc,char * argv[])
{
  int option_o = FALSE;
  int casmrun = TRUE;
  int opt;
  

  /* set yydebug = 1 use the -t option in bison to debug the parsing */
  yydebug = 0;


  while ((opt = getopt(argc,argv,"vho:")) != -1 ) {
    switch (opt) {   
    
    case 'o':
      out=fopen(optarg,"w");
      if (out==NULL) { 
	casmrun=FALSE;
      } else {
	option_o = TRUE;
      }
      break;

    case 'v' :
      printf("casm v %s - CARDIAC Assembler\n",VERSION);
      casmrun = FALSE;
      break;
    
    case '?':
      printf("\nFor help, try: casm -h\n");
      casmrun = FALSE;
      break;
    case 'h':
      fprintf(stderr,"Usage: casm [-vh] [-o <file>] <source file>\n");
      casmrun = FALSE;
      break; 
    }
  }

  /* jrv2 use yyin from flex instead of stdin */
  yyin = NULL;

  if ( casmrun && optind > 0 && argv[optind] != '\0' ) {
    yyin = fopen(argv[optind],"r");
  }
  if ( casmrun && yyin == NULL ) {
      fprintf(stderr,"error: invalid source file \"%s\"\n",argv[optind]);
      casmrun = FALSE;
  }

  if ( casmrun ) {

    if (! option_o) {
      out = fopen("a.cinc","w");
      if ( out == NULL ) {
	fprintf(stderr,"error creating a.cinc\n");
	return (1);
      }
    }

    line = 1;
    sym_ptr = NULL;
    start_ptr = NULL;
    end_ptr = NULL;
    top_proc_stack = NULL;
    
    /* proc_main initilizes the cardiac code with jump to main (JMP MAIN) and HRS */
    proc_main();
    
    yyparse();
    
    value = sym_table_check(sym_ptr);
    if ( ! value  ) {
      if ( ! casm_error) {
	code_out(start_ptr);
      }
    } else {
      fprintf(stderr,"casm error: There were %d unresolved symbols (including user and casm internal symbols)\n\n",value);
    }
    code_destroy(start_ptr);
    sym_table_destroy(sym_ptr); 
    if ( top_proc_stack != NULL) {
      fprintf(stderr,"casm error: Unmatched PROC/ENDP instructions encountered\n\n");
      while ( top_proc_stack != NULL ) {
	proc_stack_pop(&top_proc_stack,&proc_sym_ptr);
      }
    }
  }
};

