/*
 Author: Jose Romeo Vela        Date: March 24, 2002
 email: jrvela@aristasol.com
 http://www.aristasol.com/

 This software is licensed under GNU's GPL. For details see http://www.gnu.org/ 

 Copyright (c) 2002, Jose Romeo Vela

==============================================================================
Modifications:
 4/13/2002 jrv1
 Added some comments


*/

#include "config.h"
#include "cinc.h"


int main(int argc, char *argv[])
{
  int exit_code;
  struct cardiac_s  cardiac;
  
  exit_code = 0;  
  
  /* Initialize the cardiac hardware */
  exit_code=cinc_init_hw(&cardiac);
  if ( exit_code ) {
    printf("cinc exit code: %d\n",exit_code);    
    exit(exit_code);
  }

  /* Get and setup command line options */
  exit_code=setopts(argc,argv,&cardiac);
  if (exit_code ) {
    printf("cinc exit code: %d\n",exit_code);
    exit(exit_code);
  }

  /* Start the cardiac cpu emulation */
  exit_code=cinc_cpu(&cardiac);
  if (exit_code) {
    printf("cinc exit code: %d\n",exit_code); 
    exit(exit_code);
  }

  exit(exit_code);
}


